/**********************************************************************************************************************
 *  FILE DESCRIPTION
 *  -------------------------------------------------------------------------------------------------------------------
 *          File:  VED.c
 *        Config:  C:/WORK/PhiGent_APP/Applications/SipAddon/Phigent_Optimize_J5/Phigent.dpa
 *     SW-C Type:  VED
 *  Generated at:  Mon Feb 20 18:57:02 2023
 *
 *     Generator:  MICROSAR RTE Generator Version 4.19.0
 *                 RTE Core Version 1.19.0
 *       License:  CBD1900078
 *
 *   Description:  C-Code implementation template for SW-C <VED>
 *********************************************************************************************************************/


/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << Start of version logging area >>                DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/

/* PRQA S 0777, 0779 EOF */ /* MD_MSR_5.1_777, MD_MSR_5.1_779 */

/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << End of version logging area >>                  DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/

/**********************************************************************************************************************
 *
 * AUTOSAR Modelling Object Descriptions
 *
 **********************************************************************************************************************
 *
 * Data Types:
 * ===========
 * VedInfo
 *   uint8 represents integers with a minimum value of 0 and a maximum value of 255.
 *      The order-relation on uint8 is: x < y if y - x is positive.
 *      uint8 has a lexical representation consisting of a finite-length sequence 
 *      of decimal digits (#x30-#x39).
 *      
 *      For example: 1, 0, 126, +10.
 *
 *********************************************************************************************************************/

#include "Rte_VED.h" /* PRQA S 0857 */ /* MD_MSR_1.1_857 */
#include "VED_Rte_Wrapper.h"

#define CAL_START_CODE
#include "Mem_Map.h" /* PRQA S 5087 */ /* MD_MSR_MemMap */

volatile uint32 VED_UseTimeThreshold = 10000000u;

#define CAL_STOP_CODE
#include "Mem_Map.h" /* PRQA S 5087 */ /* MD_MSR_MemMap */

/*HERE*/

//uint8 Time_GetTimeStampMs(uint64* t)
//{
//	*t = 0;
//	return(uint8) 0;
//}

/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << Start of include and declaration area >>        DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/


/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << End of include and declaration area >>          DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/


/**********************************************************************************************************************
 *
 * Used AUTOSAR Data Types
 *
 **********************************************************************************************************************
 *
 * Primitive Types:
 * ================
 * VedInfo: Integer in interval [0...255]
 * boolean: Boolean (standard type)
 * float32: Real in interval [-FLT_MAX...FLT_MAX] with single precision (standard type)
 * sint16: Integer in interval [-32768...32767] (standard type)
 * uint16: Integer in interval [0...65535] (standard type)
 * uint32: Integer in interval [0...4294967295] (standard type)
 * uint8: Integer in interval [0...255] (standard type)
 *
 * Array Types:
 * ============
 * Rte_DT_EMVEDSensorMounting_t_0: Array with 8 element(s) of type uint8
 * Rte_DT_EMVEDSensor_t_0: Array with 8 element(s) of type uint8
 * Rte_DT_EMVEDVehParMain_t_0: Array with 16 element(s) of type uint8
 * Rte_DT_EMVEDswa_t_0: Array with 2 element(s) of type float32
 * Rte_DT_EMVEDswa_t_1: Array with 2 element(s) of type float32
 * Rte_DT_EMVEDvel_t_0: Array with 2 element(s) of type float32
 * Rte_DT_EMVEDvel_t_1: Array with 2 element(s) of type float32
 * Rte_DT_EMVehParAdd_t_0: Array with 12 element(s) of type uint8
 * Rte_DT_ST_VEDNvIoDatas_t_6: Array with 3 element(s) of type VEDVelCorr_t
 * Rte_DT_ST_VEDVehDyn_t_6: Array with 12 element(s) of type uint8
 * Rte_DT_VEDBrake_t_0: Array with 13 element(s) of type uint8
 * Rte_DT_VEDPowerTrain_t_4: Array with 4 element(s) of type uint8
 * Rte_DT_VEDVehSigAdd_t_0: Array with 52 element(s) of type uint8
 * Rte_DT_VEDVehSigMain_t_0: Array with 32 element(s) of type uint8
 *
 * Record Types:
 * =============
 * EMVEDSensorMounting_t: Record with elements
 *   State of type Rte_DT_EMVEDSensorMounting_t_0
 *   LatPos of type float32
 *   LongPos of type float32
 *   VertPos of type float32
 *   LongPosToCoG of type float32
 *   PitchAngle of type float32
 *   Orientation of type uint8
 *   RollAngle of type float32
 *   YawAngle of type float32
 * EMVEDSensor_t: Record with elements
 *   State of type Rte_DT_EMVEDSensor_t_0
 *   CoverDamping of type float32
 *   fCoverageAngle of type float32
 *   fLobeAngle of type float32
 *   fCycleTime of type float32
 *   uNoOfScans of type uint8
 * EMVEDStRatio_t: Record with elements
 *   swa of type EMVEDswa_t
 *   vel of type EMVEDvel_t
 * EMVEDVehParMain_t: Record with elements
 *   State of type Rte_DT_EMVEDVehParMain_t_0
 *   SelfSteerGrad of type float32
 *   SteeringRatio of type EMVEDStRatio_t
 *   DIST_FrontAxle_to_FontBumper of type float32
 *   WheelBase of type float32
 *   TrackWidthFront of type float32
 *   TrackWidthRear of type float32
 *   VehWeight of type float32
 *   CntrOfGravHeight of type float32
 *   AxisLoadDistr of type float32
 *   WhlLoadDepFrontAxle of type float32
 *   WhlLoadDepRearAxle of type float32
 *   WhlCircumference of type float32
 *   DrvAxle of type uint8
 *   WhlTcksPerRev of type uint8
 *   FrCrnrStiff of type float32
 *   ReCrnrStiff of type float32
 * EMVEDswa_t: Record with elements
 *   ang of type Rte_DT_EMVEDswa_t_0
 *   rat of type Rte_DT_EMVEDswa_t_1
 * EMVEDvel_t: Record with elements
 *   vel of type Rte_DT_EMVEDvel_t_0
 *   rat of type Rte_DT_EMVEDvel_t_1
 * EMVehParAdd_t: Record with elements
 *   State of type Rte_DT_EMVehParAdd_t_0
 *   VehicleWidth of type float32
 *   VehicleLength of type float32
 *   CurbWeight of type float32
 *   OverhangFront of type float32
 *   FrontAxleRoadDist of type float32
 *   WheelWidth of type float32
 *   PassableHeight of type float32
 *   DistCameraToHoodX of type float32
 *   DistCameraToHoodY of type float32
 *   RecordElement of type uint8
 * ENVMSignalHeader_t: Record with elements
 *   uiTimeStamp of type uint32
 *   uiMeasurementCounter of type uint16
 *   uiCycleCounter of type uint16
 *   eSigStatus of type uint8
 * ST_EMVEDVehPar_t: Record with elements
 *   uiVersionNumber of type uint32
 *   sSigHeader of type ENVMSignalHeader_t
 *   VehParMain of type EMVEDVehParMain_t
 *   VehParAdd of type EMVehParAdd_t
 *   SensorMounting of type EMVEDSensorMounting_t
 *   Sensor of type EMVEDSensor_t
 * ST_VEDNvIoDatas_t: Record with elements
 *   uiVersionNumber of type uint32
 *   sSigHeader of type VEDSignalHeader_t
 *   StWhlAng of type VEDNvStWhlAngCalc_t
 *   SlfstGrad of type VEDNvSlfStGradCalc_t
 *   YwRate of type VEDYwRate_t
 *   LatAcc of type VEDLatAcc_t
 *   VelCorr of type Rte_DT_ST_VEDNvIoDatas_t_6
 *   Wld of type VEDNvWldCalc_t
 *   State of type uint32
 *   checkSum of type uint8
 *   VED_Nf_Reserved1 of type float32
 *   VED_Nf_Reserved2 of type float32
 *   VED_Nf_Reserved3 of type float32
 *   VED_Nf_Reserved4 of type float32
 *   VED_Nf_Reserved5 of type float32
 *   VED_Nu_Reserved1 of type uint8
 *   VED_Nu_Reserved2 of type uint8
 *   VED_Nu_Reserved3 of type uint8
 *   VED_Nu_Reserved4 of type uint8
 *   VED_Nu_Reserved5 of type uint8
 *   VED_Nb_Reserved1 of type boolean
 *   VED_Nb_Reserved2 of type boolean
 *   VED_Nb_Reserved3 of type boolean
 *   VED_Nb_Reserved4 of type boolean
 *   VED_Nb_Reserved5 of type boolean
 * ST_VEDVehDyn_t: Record with elements
 *   uiVersionNumber of type uint32
 *   sSigHeader of type VEDSignalHeader_t
 *   Longitudinal of type VEDLongitudinal_t
 *   Lateral of type VEDLateral_t
 *   MotionState of type VEDMotionStateVehDyn_t
 *   Legacy of type VEDLegacyVehDyn_t
 *   rt_Array_UInt8_12_12 of type Rte_DT_ST_VEDVehDyn_t_6
 *   AddCalculateSign of type VEDAddCalculateSign_t
 * ST_VEDVehSig_t: Record with elements
 *   uiVersionNumber of type uint32
 *   sSigHeader of type VEDSignalHeader_t
 *   VehSigMain of type VEDVehSigMain_t
 *   VehSigAdd of type VEDVehSigAdd_t
 *   PowerTrain of type VEDPowerTrain_t
 *   Brake of type VEDBrake_t
 * ST_VED_CANIn: Record with elements
 *   CAN_Msg_Time of type Timestamp
 *   uiVersionNumber of type uint32
 *   sSigHeader of type VEDSignalHeader_t
 *   VehSigMain of type VEDVehSigMain_t
 *   VehSigAdd of type VEDVehSigAdd_t
 *   PowerTrain of type VEDPowerTrain_t
 *   Brake of type VEDBrake_t
 * ST_VehicleDynamicSignals_t: Record with elements
 *   timestamp_t of type Timestamp
 *   measurement_time of type Timestamp
 *   status_info of type VedInfo
 *   linear_velocity of type Vector3f
 *   linear_acceleration of type Vector3f
 *   curve of type VEDCurveVehDyn
 * Timestamp: Record with elements
 *   is_valid of type boolean
 *   secs of type uint32
 *   nsecs of type uint32
 * VEDAccelCorrVehDyn_t: Record with elements
 *   corrAccel of type float32
 *   corrAccelVar of type float32
 * VEDAddCalculateSign_t: Record with elements
 *   SpeedOdometerCalculate_mps of type float32
 * VEDBrake_t: Record with elements
 *   state of type Rte_DT_VEDBrake_t_0
 *   ABSCtrl of type boolean
 *   TCSCtrl of type boolean
 *   bESCActive_nu of type boolean
 *   bESCDisable_nu of type boolean
 *   bTCSDisable_nu of type boolean
 *   IDB5_ABAavailable of type uint8
 *   IDB5_JerkActive of type uint8
 *   IDB5_Jerkfail of type uint8
 *   IDB5_AEB_Enable of type uint8
 *   IDB7_ARPACTIVE of type boolean
 *   IDB7_ARPFailure of type uint8
 *   IDB1_FailedState of type uint8
 *   bHDCEnable_nu of type boolean
 * VEDCurveVehDyn: Record with elements
 *   curve of type float32
 *   c1 of type float32
 *   gradient of type float32
 *   var_c0 of type float32
 *   var_c1 of type float32
 *   quality of type float32
 *   crv_error of type uint8
 *   crv_conf of type boolean
 * VEDCurveVehDyn_t: Record with elements
 *   VEDCurveVehDyn_t of type float32
 *   C1 of type float32
 *   Gradient of type float32
 *   varC0 of type float32
 *   varC1 of type float32
 *   Quality of type float32
 *   CrvError of type float32
 *   CrvConf of type uint8
 * VEDDrvIntCurveVehDyn_t: Record with elements
 *   Curve of type float32
 *   Variance of type float32
 *   Gradient of type float32
 * VEDLatAcc_t: Record with elements
 *   ZeroAccel of type float32
 *   CalStatus of type uint32
 * VEDLatAccelVehDyn_t: Record with elements
 *   LatAccel of type float32
 *   Variance of type float32
 * VEDLateral_t: Record with elements
 *   YawRate of type VEDYawRateVehDyn_t
 *   OffCompStWheelAngle of type float32
 *   Curve of type VEDCurveVehDyn_t
 *   DrvIntCurve of type VEDDrvIntCurveVehDyn_t
 *   Accel of type VEDLatAccelVehDyn_t
 *   SlipAngle of type VEDSideSlipVehDyn_t
 *   fStWheelAngleGradient_rps of type float32
 * VEDLegacyVehDyn_t: Record with elements
 *   YawRateMaxJitter of type float32
 *   bStandStill of type boolean
 * VEDLongitudinal_t: Record with elements
 *   MotVar of type VEDMotVarVehDyn_t
 *   VeloCorr of type VEDVeloCorrVehDyn_t
 *   AccelCorr of type VEDAccelCorrVehDyn_t
 *   fBrakePedalPosGrad_nu of type float32
 *   fGasPedalPosGrad_nu of type float32
 * VEDMotVarVehDyn_t: Record with elements
 *   Velocity of type float32
 *   Accel of type float32
 *   varVelocity of type float32
 *   varAccel of type float32
 * VEDMotionStateVehDyn_t: Record with elements
 *   MotState of type uint8
 *   Confidence of type float32
 * VEDNvSlfStGradCalc_t: Record with elements
 *   SlfStGrad of type float32
 *   SlfStGradMax of type uint8
 *   SlfStGradMin of type uint8
 *   Dummy of type uint8
 * VEDNvStWhlAngCalc_t: Record with elements
 *   ZeroAngle of type float32
 *   CalStatus of type uint32
 * VEDNvWldCalc_t: Record with elements
 *   Wld_front of type float32
 *   Wld_rear of type float32
 *   Wld_front_quality of type uint8
 *   Wld_rear_quality of type uint8
 * VEDPowerTrain_t: Record with elements
 *   ActualGear of type uint8
 *   TargetGear of type uint8
 *   EngineRunning of type boolean
 *   FillByte of type uint8
 *   state of type Rte_DT_VEDPowerTrain_t_4
 * VEDSideSlipVehDyn_t: Record with elements
 *   SideSlipAngle of type float32
 *   Variance of type float32
 * VEDSignalHeader_t: Record with elements
 *   uiTimeStamp of type uint32
 *   uiMeasurementCounter of type uint16
 *   uiCycleCounter of type uint16
 *   eSigStatus of type uint8
 * VEDVehSigAdd_t: Record with elements
 *   State of type Rte_DT_VEDVehSigAdd_t_0
 *   EnvTemp of type float32
 *   WiperState of type uint8
 *   WiperStage of type uint8
 *   WiperOutParkPos of type boolean
 *   WiperWasherFrontState of type uint8
 *   RainSensor of type boolean
 *   TurnSignal of type uint8
 *   FogLampFront of type boolean
 *   FogLampRear of type boolean
 *   RoadWhlAngFr of type float32
 *   RoadWhlAngRe of type float32
 *   Odometer of type float32
 *   GasPedalPos of type uint8
 *   KickDown of type boolean
 *   BrakePedalPressed of type boolean
 *   DriverTired of type boolean
 *   SpeedUnit of type uint8
 *   SpeedoSpeed of type float32
 *   TrailerConnection of type uint8
 *   TrailerConnBeforeShutDown of type uint8
 *   TrailerLengthInput of type uint8
 *   ParkAidDet_L of type uint8
 *   ParkAidDet_CL of type uint8
 *   ParkAidDet_CR of type uint8
 *   ParkAidDet_R of type uint8
 *   IgnitionSwitch of type uint8
 *   eSuspensionSystem of type uint8
 *   eHeightLevel of type uint8
 *   WheelHeightLevel of type VEDWheelHeightLevel_t
 *   bDriverSeatBelt_nu of type boolean
 *   bDoorAllClosed_nu of type boolean
 *   bLowBeamActive_nu of type boolean
 *   bHighBeamActive_nu of type boolean
 *   bHazardLightActive_nu of type boolean
 *   fBrakePedalPos_nu of type float32
 *   uFrontLampState_nu of type uint8
 *   CDCS11_VoiceMode of type uint8
 *   CDCS11_ADAS_SndCtrlOnOff of type uint8
 *   EPS1_TorsionBarTorque of type float32
 *   CS1_GearPositionReqSt of type uint8
 *   EPS2_ADAS_Available of type uint8
 *   EPS2_ADAS_Active of type uint8
 *   EPS2_MotCntrl of type float32
 *   EPS2_ADAS_CtrlAbortFeedback of type uint8
 *   DDCU1_FLDoorAjar of type uint8
 *   DDCU1_RLDoorAjar of type uint8
 *   PDCU1_FRDoorAjar of type uint8
 *   PDCU1_RRDoorAjar of type uint8
 *   BDCS1_TrunkLockSts of type uint8
 *   BDCS1_HoodAjarSts of type uint8
 *   CDCS5_ResetAllSetup of type uint8
 *   CDCS5_FactoryReset of type uint8
 * VEDVehSigMain_t: Record with elements
 *   state of type Rte_DT_VEDVehSigMain_t_0
 *   YawRate of type float32
 *   YawRateTemp of type float32
 *   StWheelAngle of type float32
 *   LatAccel of type float32
 *   WhlVelFrLeft of type float32
 *   WhlVelFrRight of type float32
 *   WhlVelReLeft of type float32
 *   WhlVelReRight of type float32
 *   YawRateInt of type float32
 *   YawRateIntTemp of type float32
 *   LongAccel of type float32
 *   RearWhlAngle of type float32
 *   VehVelocityExt of type float32
 *   VehLongAccelExt of type float32
 *   WhlDirFrLeft of type uint8
 *   WhlDirFrRight of type uint8
 *   WhlDirReLeft of type uint8
 *   WhlDirReRight of type uint8
 *   WhlTicksDevFrLeft of type uint8
 *   WhlTicksDevFrRight of type uint8
 *   WhlTicksDevReLeft of type uint8
 *   WhlTicksDevReRight of type uint8
 *   ActGearPos of type uint8
 *   BrakeActLevel of type uint16
 *   ParkBrakeState of type uint8
 *   VehLongDirExt of type uint8
 *   VehLongMotStateExt of type uint8
 *   CurveC0Ext of type float32
 *   CurveC1Ext of type float32
 *   SideSlipAngleExt of type float32
 *   fStWheelAngleGradient_nu of type float32
 * VEDVelCorr_t: Record with elements
 *   CorrFact of type float32
 *   Velo of type float32
 *   Dev of type float32
 * VEDVeloCorrVehDyn_t: Record with elements
 *   corrFact of type float32
 *   corrVar of type float32
 *   corrVelo of type float32
 *   corrVeloVar of type float32
 *   minVelo of type float32
 *   maxVelo of type float32
 *   corrQual of type uint8
 *   bRollerTestBench of type boolean
 * VEDWheelHeightLevel_t: Record with elements
 *   FrontLeft of type sint16
 *   FrontRight of type sint16
 *   RearLeft of type sint16
 *   RearRight of type sint16
 * VEDYawRateVehDyn_t: Record with elements
 *   YawRate of type float32
 *   Variance of type float32
 *   Quality of type float32
 * VEDYwRate_t: Record with elements
 *   ZeroRate of type float32
 *   ZeroRateMin of type float32
 *   ZeroRateMax of type float32
 *   CalStatus of type uint32
 * Vector3f: Record with elements
 *   x of type float32
 *   y of type float32
 *   z of type float32
 *
 *********************************************************************************************************************/


#define VED_START_SEC_CODE
#include "VED_MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */

/**********************************************************************************************************************
 *
 * Runnable Entity Name: VED_Init
 *
 *---------------------------------------------------------------------------------------------------------------------
 *
 * Executed once after the RTE is started
 *
 **********************************************************************************************************************
 *
 * Input Interfaces:
 * =================
 *   Explicit S/R API:
 *   -----------------
 *   Std_ReturnType Rte_Read_rCANMsg_ST_VED_CANIn_ST_VED_CANIn(ST_VED_CANIn *data)
 *   Std_ReturnType Rte_Read_rNVRAM_ST_VEDNvIoDatas_t_ST_VEDNvIoDatas_t(ST_VEDNvIoDatas_t *data)
 *
 * Output Interfaces:
 * ==================
 *   Explicit S/R API:
 *   -----------------
 *   Std_ReturnType Rte_Write_pVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t(const ST_EMVEDVehPar_t *data)
 *   Std_ReturnType Rte_Write_pVED_ST_VEDNvIoDatas_t_ST_VEDNvIoDatas_t(const ST_VEDNvIoDatas_t *data)
 *   Std_ReturnType Rte_Write_pVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t(const ST_VEDVehDyn_t *data)
 *   Std_ReturnType Rte_Write_pVED_ST_VEDVehSig_t_ST_VEDVehSig_t(const ST_VEDVehSig_t *data)
 *   Std_ReturnType Rte_Write_pVED_VehicleDynamicSignals_t_VehicleDynamicSignals_t(const ST_VehicleDynamicSignals_t *data)
 *
 *********************************************************************************************************************/
/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << Start of documentation area >>                  DO NOT CHANGE THIS COMMENT!
 * Symbol: VED_Init_doc
 *********************************************************************************************************************/


/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << End of documentation area >>                    DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/

FUNC(void, VED_CODE) VED_Init(void) /* PRQA S 0850 */ /* MD_MSR_19.8 */
{
/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << Start of runnable implementation >>             DO NOT CHANGE THIS COMMENT!
 * Symbol: VED_Init
 *********************************************************************************************************************/
    static volatile uint32 VED_Init_Counter = 0;
    VED_Init_Counter++;
    VED_Initialize();

/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << End of runnable implementation >>               DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/
}

/**********************************************************************************************************************
 *
 * Runnable Entity Name: VED_Step
 *
 *---------------------------------------------------------------------------------------------------------------------
 *
 * Executed if at least one of the following trigger conditions occurred:
 *   - triggered on TimingEvent every 20ms
 *
 **********************************************************************************************************************
 *
 * Input Interfaces:
 * =================
 *   Explicit S/R API:
 *   -----------------
 *   Std_ReturnType Rte_Read_ST_CarConfigParamOut_ST_CarConfigParamOut(ST_CarConfigParamOut *data)
 *   Std_ReturnType Rte_Read_ST_VEDNvIoDatas_Read_t_ST_VEDNvIoDatas_Read_t(ST_VEDNvIoDatas_t *data)
 *   Std_ReturnType Rte_Read_ST_VED_CANIn_ST_VED_CANIn(ST_VED_CANIn *data)
 *   Std_ReturnType Rte_Read_ST_VED_NVRAMData_ReceiveFlag_ST_VED_NVRAMData_ReceiveFlag(boolean *data)
 *
 * Output Interfaces:
 * ==================
 *   Explicit S/R API:
 *   -----------------
 *   Std_ReturnType Rte_Write_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t(const ST_EMVEDVehPar_t *data)
 *   Std_ReturnType Rte_Write_ST_VEDNvIoDatas_Write_t_ST_VEDNvIoDatas_Write_t(const ST_VEDNvIoDatas_t *data)
 *   Std_ReturnType Rte_Write_ST_VEDVehDyn_t_ST_VEDVehDyn_t(const ST_VEDVehDyn_t *data)
 *   Std_ReturnType Rte_Write_ST_VEDVehSig_t_ST_VEDVehSig_t(const ST_VEDVehSig_t *data)
 *   Std_ReturnType Rte_Write_ST_VehicleDynamicSignals_t_ST_VehicleDynamicSignals_t(const ST_VehicleDynamicSignals_t *data)
 *   Std_ReturnType Rte_Write_ST_adcu_ved_dtc_ST_adcu_ved_dtc(const ST_adcu_ved_dtc *data)
 *
 *********************************************************************************************************************/
/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << Start of documentation area >>                  DO NOT CHANGE THIS COMMENT!
 * Symbol: VED_Step_doc
 *********************************************************************************************************************/


/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << End of documentation area >>                    DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/
//#define VED_CPU_LOAD_DEBUG
FUNC(void, VED_CODE) VED_Step(void) /* PRQA S 0624, 3206 */ /* MD_Rte_0624, MD_Rte_3206 */
{
/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << Start of runnable implementation >>             DO NOT CHANGE THIS COMMENT!
 * Symbol: VED_Step
 *********************************************************************************************************************/
    static volatile uint32 VED_20ms_Counter = 0;

#ifdef VED_CPU_LOAD_DEBUG
    static volatile uint32 VED_UseTime = 0;
    static volatile uint32 VED_StepTime = 0;
    static volatile uint64 VED_RecordTime = 0;
    StbM_TimeStampType timeStamp;
    StbM_UserDataType userData;
    uint64 tempTime;
    Hirain_StbM_GetCurrentTime(0, &timeStamp, &userData);
    tempTime = ((uint64)timeStamp.seconds * 1000000000u) +
               ((uint64)timeStamp.nanoseconds);
    VED_StepTime = tempTime - VED_RecordTime;
    VED_RecordTime = tempTime;
#endif

    VED_20ms_Counter++;
    VED_StepExec();

#ifdef VED_CPU_LOAD_DEBUG
    Hirain_StbM_GetCurrentTime(0, &timeStamp, &userData);
    VED_UseTime = ((uint64)timeStamp.seconds * 1000000000u) +
                  ((uint64)timeStamp.nanoseconds) - tempTime;

    static ST_adcu_ved_dtc VEDRunTime_adcu_ved_dtc;
    memset(&VEDRunTime_adcu_ved_dtc, 0, sizeof(ST_adcu_ved_dtc));

    if (VED_UseTime > VED_UseTimeThreshold) {
        VEDRunTime_adcu_ved_dtc.adcu_ved_dtc[2].dtc = 0xA573;
        VEDRunTime_adcu_ved_dtc.adcu_ved_dtc[2].event_id = 0X8;
        VEDRunTime_adcu_ved_dtc.adcu_ved_dtc[2].status = 0X1;
    } else {
        VEDRunTime_adcu_ved_dtc.adcu_ved_dtc[2].dtc = 0x0;
        VEDRunTime_adcu_ved_dtc.adcu_ved_dtc[2].event_id = 0x0;
        VEDRunTime_adcu_ved_dtc.adcu_ved_dtc[2].status = 0x0;
    }
    Rte_Write_ST_adcu_ved_dtc_ST_adcu_ved_dtc(&VEDRunTime_adcu_ved_dtc);
#endif

/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << End of runnable implementation >>               DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/
}


#define VED_STOP_SEC_CODE
#include "VED_MemMap.h" /* PRQA S 5087 */ /* MD_MSR_19.1 */


/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << Start of function definition area >>            DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/


/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << End of function definition area >>              DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/


/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << Start of removed code area >>                   DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/


/**********************************************************************************************************************
 * DO NOT CHANGE THIS COMMENT!           << End of removed code area >>                     DO NOT CHANGE THIS COMMENT!
 *********************************************************************************************************************/

/**********************************************************************************************************************
 MISRA 2012 violations and justifications
 *********************************************************************************************************************/

/* module specific MISRA deviations:
   MD_Rte_0624:  MISRA rule: Rule8.3
     Reason:     This MISRA violation is a consequence from the RTE requirements [SWS_Rte_01007] [SWS_Rte_01150].
                 The typedefs are never used in the same context.
     Risk:       No functional risk. Only a cast to uint8* is performed.
     Prevention: Not required.

   MD_Rte_3206:  MISRA rule: Rule2.7
     Reason:     The parameter are not used by the code in all possible code variants.
     Risk:       No functional risk.
     Prevention: Not required.

*/
